`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 2018/03/29 20:12:21
// Design Name: 
// Module Name: FSM
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////

`define STAT_PAUSE 1'b0
`define STAT_COUNT 1'b1
`define ENABLED 1'b1
`define DISABLED 1'b0

`define first_num 2'b00
`define plus 2'b01
`define second_num 2'b10
`define Result 2'b11
module FSM(
in, //input control
clk, // global clock signal
rst, // high active reset
state,
Digit_3,
Digit_2,
Digit_1,
Digit_0,
Keyboard_in
);

// inputs
input clk; // global clock signal
input rst; // high active reset
input in; //input control
input [3:0]Keyboard_in;
output reg [3:0]Digit_3, Digit_2, Digit_1, Digit_0;
reg [3:0]Digit_3_tmp, Digit_2_tmp, Digit_1_tmp, Digit_0_tmp;
reg [4:0]Result;
reg [4:0]Result_tmp;
output reg [1:0]state; // state of FSM
reg [1:0]next_state; // next state of FSM

// FSM state decision
always @*
  case (state)
    `first_num:
    if (in)
        begin
        next_state = `plus;
        Digit_3_tmp = Keyboard_in;
        Digit_2_tmp = Digit_2;  //useless
        Result_tmp = 4'd0;          //useless
        end
    else
        begin
        next_state = `first_num;
        Digit_3_tmp = Digit_3; 
        Digit_2_tmp = Digit_2;  //useless
        Result_tmp = Result;          
        end
    `plus:
    if (in)
        begin
        next_state = `second_num;
        Digit_3_tmp = Digit_3;   //useless
        Digit_2_tmp = Digit_2;   //useless 
        Result_tmp = 4'd0;           //useless
        end
    else
        begin
        next_state = `plus;
        Digit_3_tmp = Digit_3;  //useless 
        Digit_2_tmp = Digit_2;  //useless 
        Result_tmp = 4'd0;          //useless 
        end
    `second_num:
    if (in)
         begin
         next_state = `Result;
         Digit_3_tmp = Digit_3;   //useless
         Digit_2_tmp = Keyboard_in;
         Result_tmp = 4'd0;          //useless 
         end
    else
         begin
         next_state = `second_num;
         Digit_3_tmp = Digit_3;   //useless
         Digit_2_tmp = Digit_2;
         Result_tmp = 4'd0;          //useless 
         end
    `Result:
    if (in)
         begin
         next_state =  `first_num;
         Digit_3_tmp = Digit_3;   
         Digit_2_tmp = Digit_2;     
         Result_tmp = Digit_3 + Digit_2;  
         end
    else
         begin
         next_state = `Result;
         Digit_3_tmp = Digit_3;     //useless
         Digit_2_tmp = Digit_2;     //useless
         Result_tmp = Digit_3 + Digit_2;
         end
  default:  //useless
     if (in)
           begin
           next_state =  `first_num;
           Digit_3_tmp = 4'd0  ;   
           Digit_2_tmp = 4'd0;     
           Result_tmp = 4'd0;  
           end
     else
           begin
           next_state = `Result;
           Digit_3_tmp = Digit_3  ;   //useless
           Digit_2_tmp = Digit_2;     //useless
           Result_tmp = Digit_3 + Digit_2;
           end
    endcase
    
always @*
    begin
        Digit_1_tmp = Result / 10;
        Digit_0_tmp = Result % 10;
    end
    
    // FSM state transition
always @(posedge clk or posedge rst)
    if (rst)
        state <= `first_num;
    else
        state <= next_state;
        
always @(posedge clk or posedge rst)
    if(rst)
        begin
            Digit_3 <= 4'd0;
            Digit_2 <= 4'd0;
            Digit_1 <= 4'd0;
            Digit_0 <= 4'd0; 
            Result <= 4'd0;     
        end
    else
        begin
            Digit_3 <= Digit_3_tmp;
            Digit_2 <= Digit_2_tmp;
            Digit_1 <= Digit_1_tmp;
            Digit_0 <= Digit_0_tmp;      
            Result <= Result_tmp;
        end
    
    endmodule
