`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 05/05/2020 01:39:25 PM
// Design Name: 
// Module Name: Lab9_2
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module Lab9_2(
    f_crystal,
    rst,
    PS2_CLK,
    PS2_DATA,
    D_ssd,
    ssd_ctl
    );
    input f_crystal, rst;
    inout PS2_DATA, PS2_CLK;
    output [7:0]D_ssd;
    output [3:0]ssd_ctl;
    wire [511:0]key_down;
    wire [8:0]last_change;
    wire key_valid;
    wire [3:0]Display;
    wire [1:0]state, ssd_clk;
    wire [3:0]first_num, second_num, Result_MSB, Result_LSB;
    wire [3:0]digit;
    wire clk_10;
    frq_div_clk U0(
    .ssd_clk(ssd_clk),
    .f_crystal(f_crystal), // global clock input
    .rst(rst), // active low reset
    .clk_10(clk_10)
    );
    KeyboardDecoder U1(
    .key_down(key_down),
    .last_change(last_change),
    .key_valid(key_valid),
    .PS2_DATA(PS2_DATA),
    .PS2_CLK(PS2_CLK),
    .rst(rst),
    .clk(f_crystal)
    );
     Keyboard_converter U2(
    .in(last_change),
    .out(digit)
    );
    FSM U_FSM(
    .in(key_valid), //input control
    .clk(f_crystal), // global clock signal
    .rst(rst), // high active reset
    .state(state),
    .Keyboard_in(digit),
    .Digit_3(first_num),
    .Digit_2(second_num),
    .Digit_1(Result_MSB),
    .Digit_0(Result_LSB)
    );
    
    scan_ctl U3(
    .ssd_ctl(ssd_ctl), // ssd display control signal 
    .ssd_in0(first_num), // output to ssd display
    .ssd_in1(second_num),
    .ssd_in2(Result_MSB),
    .ssd_in3(Result_LSB),
    .ssd_in(Display),
    .ssd_ctl_clk(ssd_clk)
    );
    Display_7_segment U4(.D_ssd(D_ssd), .i(Display));
endmodule
